#ifndef __NCES_CAN_H__
#define __NCES_CAN_H__

#include "Os.h"
#include "prc_sil.h"
#include "de0_nano.h"

/*
 *  NCES CAN ̃WX^`
 */
#define EXTEND_CAN_ID_LENGTH	18U             /* gCAN-ID */
#define ACCEPTANCE_OFFSET		21U             /* ANZv^XR[hWX^̃ItZbg */
#define ACCEPTANCE_MASK			0x001FFFFFU     /* ANZv^X}XNWX^ɐݒ肷}XN */

/* [hWX^ */
#define RESET_MODE			0x00000001U                                                                 /* 샂[hRESET_MODEɂ */
#define OPERATING_MODE		0x00000000U                                                                 /* 샂[hOPERATING_MODEɂ */
#define LISTEN_ONLY_MODE	0x00000002U                                                                 /* M֎~ */
#define NO_LISTEN_ONLY_MODE	0x00000000U                                                                 /* M */
#define NO_SEND_ACK_MODE	0x00000004U                                                                 /* ACKM֎~ */
#define SEND_ACK_MODE		0x00000000U                                                                 /* ACKM */
#define SINGLE_FILTER_MODE	0x00000008U                                                                 /* Single filter mode */
#define DUAL_FILTER_MODE	0x00000000U                                                                 /* Dual filter mode */
#define CANC_MODE_START		(OPERATING_MODE | NO_LISTEN_ONLY_MODE | SEND_ACK_MODE | SINGLE_FILTER_MODE) /* CANRg[START */
#define CANC_MODE_STOP		(RESET_MODE     | NO_LISTEN_ONLY_MODE | SEND_ACK_MODE | SINGLE_FILTER_MODE) /* CANRg[STOP */

/* ݗv */
#define RECEIVE_IRQ			0x00000001U     /* M */
#define TRANSMIT_IRQ		0x00000002U     /* M */

#define IRQ_SET_DISABLE		0x00000000U     /* [݋WX^]Sݗv֎~ */
#define IRQ_SET_ENABLE		0x000000FFU     /* [݋WX^]ẘݗv */
#define TXABORT_CLEAR		0x0000FFFFU     /* [MLZWX^]SbZ[W{bNXMLZ */
#define TXCMP_CLEAR			0x0000FFFFU     /* [MWX^]MrbgNA */
#define TXABORTCMP_CLEAR	0x0000FFFFU     /* [MLZWX^]MLZrbgNA */
#define RXWAIT_OFF			0x00000000U     /* [MEFCgWX^]EFCgOFF */
#define RXCMP_CLEAR			0xFFFFFFFFU     /* [MWX^]MrbgNA */
#define RXSELFREQ_CLEAR		0x00000000U     /* [ZtMvWX^]MvȂ */
#define ERROR_CNT_CLEAR		0x00000060U     /* [G[JE^WX^]G[JE^lɂ */
#define BAUDRATE_250		0x80007F03U     /* [NbNCoX^C~OWX^]{[[g:250kbps */
#define BAUDRATE_500		0x80007F01U     /* [NbNCoX^C~OWX^]{[[g:500kbps */
#define IRQ_RXEN_PERMIT		0xFFFFFFFFU     /* [M荞݋WX^]M荞݋ */

#define MASK_CAN_ID_MASK	0x1FFFFFFFU     /* CanId擾}XN */
#define MASK_4BIT			0x0000000FU     /* 4rbg}XN */
#define MASK_8BIT			0x000000FFU     /* 8rbg}XN */

/*  */
/* eWX^܂ł̃ItZbgAhX */
#define CANC_MODE_REG							0x0000U     /* [h */
#define CANC_TXREQ_REG							0x0004U
#define CANC_TXABORT_REG						0x0008U     /* MLZWX^ */
#define CANC_TXCMP_REG							0x000CU
#define CANC_TXABORTCMP_REG						0x0010U
#define CANC_RXWAIT_REG							0x0014U
#define CANC_RXCMP_REG							0x0018U
#define CANC_RXOVERWRITE_REG					0x001CU
#define CANC_RXSELFREQ_REG						0x0020U
#define CANC_STATUS_REG							0x0024U
#define CANC_IRQ_REG							0x0028U
#define CANC_IRQ_EN_REG							0x002CU     /* ݋WX^ */
#define CANC_IRQ_RXEN_REG						0x0030U
#define CANC_CLKDIV_BUSTIM_REG					0x0034U     /* NbNCoX^C~O */
#define CANC_ACCEPTANCE_CODE_REG				0x0038U     /* ANZv^XR[hWX^ */
#define CANC_ACCEPTANCE_MASK_REG				0x003CU     /* ANZv^X}XNWX^ */
#define CANC_ARBITRATION_LOST_CAPTURE_REG		0x0040U
#define CANC_ERROR_CAPTURE_CODE_REG				0x0044U
#define CANC_ERROR_CNT_REG						0x0048U
#define CANC_MBOXWIN_REG						0x004CU     /* bZ[W{bNXEBhEWX^ */
#define CANC_RXMBOX_ACCEPTANCE_CODE_REG			0x0070U     /* MbZ[W{bNX̃ANZv^XR[hWX^ */
#define CANC_RXMBOX_ACCEPTANCE_MASK_REG			0x0074U     /* MbZ[W{bNX̃ANZv^X}XNWX^ */
#define CANC_TXMBOX_DATA0_REG					0x0100U
#define CANC_TXMBOX_DATA1_REG					0x0104U
#define CANC_TXMBOX_DATA2_REG					0x0108U
#define CANC_TXMBOX_DATA3_REG					0x010CU
#define CANC_RXMBOX_DATA0_REG					0x0200U
#define CANC_RXMBOX_DATA1_REG					0x0204U
#define CANC_RXMBOX_DATA2_REG					0x0208U
#define CANC_RXMBOX_DATA3_REG					0x020CU

#define SIL_REW_IOP_CANC_0_BASE(mem)		sil_rew_iop((void *) (CANC_0_BASE + (mem)))
#define SIL_WRW_IOP_CANC_0_BASE(mem, data)	sil_wrw_iop((void *) (CANC_0_BASE + (mem)), (data))

/* ǎpWX^ANZX}N */
#define CANC_RD_TXCMP_REG()							SIL_REW_IOP_CANC_0_BASE(CANC_TXCMP_REG)
#define CANC_RD_TXABORTCMP_REG()					SIL_REW_IOP_CANC_0_BASE(CANC_TXABORTCMP_REG)
#define CANC_RD_RXWAIT_REG()						SIL_REW_IOP_CANC_0_BASE(CANC_RXWAIT_REG)
#define CANC_RD_RXCMP_REG()							SIL_REW_IOP_CANC_0_BASE(CANC_RXCMP_REG)
#define CANC_RD_RXOVERWRITE_REG()					SIL_REW_IOP_CANC_0_BASE(CANC_RXOVERWRITE_REG)
#define CANC_RD_STATUS_REG()						SIL_REW_IOP_CANC_0_BASE(CANC_STATUS_REG)
#define CANC_RD_IRQ_REG()							SIL_REW_IOP_CANC_0_BASE(CANC_IRQ_REG)
#define CANC_RD_CLKDIV_BUSTIM_REG()					SIL_REW_IOP_CANC_0_BASE(CANC_CLKDIV_BUSTIM_REG)
#define CANC_RD_ERROR_CNT_REG()						SIL_REW_IOP_CANC_0_BASE(CANC_ERROR_CNT_REG)
#define CANC_RD_RXMBOX_DATA0_REG(box_num)			SIL_REW_IOP_CANC_0_BASE((CANC_RXMBOX_DATA0_REG + (0x0010U * (box_num))))
#define CANC_RD_RXMBOX_DATA1_REG(box_num)			SIL_REW_IOP_CANC_0_BASE((CANC_RXMBOX_DATA1_REG + (0x0010U * (box_num))))
#define CANC_RD_RXMBOX_DATA2_REG(box_num)			SIL_REW_IOP_CANC_0_BASE((CANC_RXMBOX_DATA2_REG + (0x0010U * (box_num))))
#define CANC_RD_RXMBOX_DATA3_REG(box_num)			SIL_REW_IOP_CANC_0_BASE((CANC_RXMBOX_DATA3_REG + (0x0010U * (box_num))))

/* ݗpWX^ANZX}N */
#define CANC_WR_MODE_REG(data)						SIL_WRW_IOP_CANC_0_BASE(CANC_MODE_REG, data)
#define CANC_WR_TXREQ_REG(data)						SIL_WRW_IOP_CANC_0_BASE(CANC_TXREQ_REG, data)
#define CANC_WR_TXABORT_REG(data)					SIL_WRW_IOP_CANC_0_BASE(CANC_TXABORT_REG, data)
#define CANC_WR_TXCMP_REG(data)						SIL_WRW_IOP_CANC_0_BASE(CANC_TXCMP_REG, data)
#define CANC_WR_TXABORTCMP_REG(data)				SIL_WRW_IOP_CANC_0_BASE(CANC_TXABORTCMP_REG, data)
#define CANC_WR_RXWAIT_REG(data)					SIL_WRW_IOP_CANC_0_BASE(CANC_RXWAIT_REG, data)
#define CANC_WR_RXCMP_REG(data)						SIL_WRW_IOP_CANC_0_BASE(CANC_RXCMP_REG, data)
#define CANC_WR_RXSELFREQ_REG(data)					SIL_WRW_IOP_CANC_0_BASE(CANC_RXSELFREQ_REG, data)
#define CANC_WR_IRQ_EN_REG(data)					SIL_WRW_IOP_CANC_0_BASE(CANC_IRQ_EN_REG, data)
#define CANC_WR_IRQ_RXEN_REG(data)					SIL_WRW_IOP_CANC_0_BASE(CANC_IRQ_RXEN_REG, data)
#define CANC_WR_CLKDIV_BUSTIM_REG(data)				SIL_WRW_IOP_CANC_0_BASE(CANC_CLKDIV_BUSTIM_REG, data)
#define CANC_WR_ACCEPTANCE_CODE_REG(data)			SIL_WRW_IOP_CANC_0_BASE(CANC_ACCEPTANCE_CODE_REG, data)
#define CANC_WR_ACCEPTANCE_MASK_REG(data)			SIL_WRW_IOP_CANC_0_BASE(CANC_ACCEPTANCE_MASK_REG, data)
#define CANC_WR_ERROR_CNT_REG(data)					SIL_WRW_IOP_CANC_0_BASE(CANC_ERROR_CNT_REG, data)
#define CANC_WR_MBOXWIN_REG(box_num)				SIL_WRW_IOP_CANC_0_BASE(CANC_MBOXWIN_REG, ((box_num) << 16))
#define CANC_WR_RXMBOX_ACCEPTANCE_CODE_REG(data)	SIL_WRW_IOP_CANC_0_BASE(CANC_RXMBOX_ACCEPTANCE_CODE_REG, data)
#define CANC_WR_RXMBOX_ACCEPTANCE_MASK_REG(data)	SIL_WRW_IOP_CANC_0_BASE(CANC_RXMBOX_ACCEPTANCE_MASK_REG, data)
#define CANC_WR_TXMBOX_DATA0_REG(data, box_num)		SIL_WRW_IOP_CANC_0_BASE((CANC_TXMBOX_DATA0_REG + (0x0010U * (box_num))), data)
#define CANC_WR_TXMBOX_DATA1_REG(data, box_num)		SIL_WRW_IOP_CANC_0_BASE((CANC_TXMBOX_DATA1_REG + (0x0010U * (box_num))), data)
#define CANC_WR_TXMBOX_DATA2_REG(data, box_num)		SIL_WRW_IOP_CANC_0_BASE((CANC_TXMBOX_DATA2_REG + (0x0010U * (box_num))), data)
#define CANC_WR_TXMBOX_DATA3_REG(data, box_num)		SIL_WRW_IOP_CANC_0_BASE((CANC_TXMBOX_DATA3_REG + (0x0010U * (box_num))), data)

/*----------------------------------------------------------------------
	}N`
----------------------------------------------------------------------*/
#define	DIR_RECV			( 0 )				/* M */
#define	DIR_SEND			( 1 )				/* M */

/* Xe[^X֌W */
#define	STATUS_OK			( 0 )
#define	STATUS_ERROR		( 1 )

#define	STATUS_READY		( 2 )
#define	STATUS_SEND			( 3 )
#define	STATUS_RECV			( 4 )

#define BYTE_LENGTH			( 4 )


/*----------------------------------------------------------------------
	^Cv`
----------------------------------------------------------------------*/
/* Xe[^X */
typedef uint8 STATUS;

/*----------------------------------------------------------------------
	vg^Cv錾
----------------------------------------------------------------------*/
extern STATUS NcanInit(uint8 no);
extern void NcanEnable(uint8 no);
extern void NcanDisable(uint8 no);
extern STATUS NcanComStatus(uint8 no);
extern STATUS NcanSetTxData(uint8 no, uint8 mb_num, uint8 id, uint8 *p_data, uint8 len );
extern STATUS NcanGetRxData(uint8 no, uint8 mb_num, uint8 *p_data, uint8 *p_len );
extern STATUS NcanSetMailBoxInfo(uint8 no, uint8 mb_num, uint8 direction,
								uint8 ide, uint32 id, uint8 mask, uint32 remote);

extern void Ncan0InterruptRx(void);
extern void Ncan0InterruptTx(void);

/*----------------------------------------------------------------------
	O[oϐiOQƁj
----------------------------------------------------------------------*/

#endif /* __NCES_CAN_H__ */

